from data_generator import *
import scipy.optimize as opt


def fineMatch(match, distance):
    a = len(match)
    b = len(match.T)
    for i in range(a):
        for j in range(b):
            if match[i][j] == 1:
                if distance[i][j] > 0:
                    match[i][j] = 0
    return match


G, feature_g = groundTruth()
B, feature_bb, transform1 = dataGenerator(G, feature_g, False, 0.2)
C, feature_cc, transform2 = dataGenerator(G, feature_g, False, 0.2)

matD = distance(feature_bb, feature_cc)
alg0 = training(B, C, matD, 0)
alg00 = training(B, C, matD, 1.0)

E, feature_e, transform3 = dataGenerator(G, feature_g, False, 0.9)
matD1 = distance(feature_e, feature_bb)
matD2 = distance(feature_e, feature_cc)
alg1 = training(E, B, matD1, 1.0)
alg2 = training(E, C, matD2, 1.0)
alg1 = fineMatch(alg1, matD1)
alg2 = fineMatch(alg2, matD2)

F, feature_f, transform4 = dataGenerator(G, feature_g, False, 0.9)
matD3 = distance(feature_f, feature_bb)
matD4 = distance(feature_f, feature_cc)
alg3 = training(F, B, matD3, 1.0)
alg4 = training(F, C, matD4, 1.0)
alg3 = fineMatch(alg3, matD3)
alg4 = fineMatch(alg4, matD4)

print("BC 0")
accuracy(np.matmul(transform1.T, transform2), alg0)
print("BC 1")
accuracy(np.matmul(transform1.T, transform2), alg00)

print("EB")
accuracy(np.matmul(transform3.T, transform1), alg1)
print("EC")
accuracy(np.matmul(transform3.T, transform2), alg2)
print("FB")
accuracy(np.matmul(transform4.T, transform1), alg3)
print("FC")
accuracy(np.matmul(transform4.T, transform2), alg4)

alg_mixture = np.matmul(alg1.T, alg2) + np.matmul(alg3.T, alg4)
row, col = opt.linear_sum_assignment(-alg_mixture)
a = len(alg_mixture)
b = len(alg_mixture.T)
alg_mixture = np.zeros((a, b))
c = a
if a > b:
    c = b
for i in range(c):
    alg_mixture[row[i]][col[i]] = 1

print("indirect")
accuracy(np.matmul(transform1.T, transform2), np.matmul(alg1.T, alg2))
accuracy(np.matmul(transform1.T, transform2), np.matmul(alg3.T, alg4))
accuracy(np.matmul(transform1.T, transform2), alg_mixture)
